/* DO NOT EDIT THIS FILE - it is machine generated */
#include <jni.h>
#include <string.h>
#include <android/log.h>
#include <stdlib.h>
#include <stdio.h>

#include "task_manager_interface.h"
#include "com_xunlei_downloadlib_XLLoader.h"

extern "C" {

#define __ANDROID_LOG_TAG__ ("JNI_XLDownloadLib")

// Log switch
#define __ANDROID_LOG__

#ifdef __ANDROID_LOG__
#define ANDROID_DEBUG_LOG(...) (__android_log_print(ANDROID_LOG_DEBUG, __ANDROID_LOG_TAG__, __VA_ARGS__))
#define ANDROID_WARN_LOG(...) (__android_log_print(ANDROID_LOG_WARN, __ANDROID_LOG_TAG__, __VA_ARGS__))
#define ANDROID_ERROR_LOG(...) (__android_log_print(ANDROID_LOG_ERROR, __ANDROID_LOG_TAG__, __VA_ARGS__))
#else
#define ANDROID_DEBUG_LOG(...)
#define ANDROID_WARN_LOG(...)
#define ANDROID_ERROR_LOG(...)
#endif

#define releaseString(A, B)  env->ReleaseStringUTFChars(A, B)

enum XL_JNI_RES_TYPE
{
	XL_JNI_PEER_RES   = 10,
	XL_JNI_SERVER_RES = 20,
};

enum XL_JNI_ERROR_CODE
{
    XL_JNI_ERROR = 7000,
    XL_JNI_SO_ERROR = 7001,
};

void bin2hex(char *bin, unsigned int binLen, char *hex);
void hex2bin(char *hex, unsigned int hexLen, char *bin);
jstring strToJstring(JNIEnv* env, const char *pStr);

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    init
 * Signature: (Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_init(
        JNIEnv *env, jobject obj, jstring appKey, jstring appName,
        jstring appVersion, jstring reservedField, jstring peerId, jstring guid,
        jstring statSavePath, jstring statCfgSavePath, jint netType, jint dataBufferSize)
{
    InitParam stInitParam;

    stInitParam.pstrAppKey = env->GetStringUTFChars(appKey, NULL);
    stInitParam.nAppKeySize = (NULL != stInitParam.pstrAppKey) ? strlen(stInitParam.pstrAppKey) : 0;

    stInitParam.pstrAppName = env->GetStringUTFChars(appName, NULL);
    stInitParam.nAppNameSize = (NULL != stInitParam.pstrAppName) ? strlen(stInitParam.pstrAppName) : 0;

    stInitParam.pstrAppVersion = env->GetStringUTFChars(appVersion, NULL);
    stInitParam.nAppVersionSize = (NULL != stInitParam.pstrAppVersion) ? strlen(stInitParam.pstrAppVersion) : 0;

    //使用者不设置reserved_field参数时，该参数可能为NULL
    if (reservedField != NULL) {
    	stInitParam.pstrReservedField = env->GetStringUTFChars(reservedField, NULL);
    } else {
    	stInitParam.pstrReservedField = "";
    }
    stInitParam.nReservedFieldSize = (NULL != stInitParam.pstrReservedField) ? strlen(stInitParam.pstrReservedField) : 0;

    stInitParam.pstrPeerId = env->GetStringUTFChars(peerId, NULL);
    stInitParam.nPeerIdSize = (NULL != stInitParam.pstrPeerId) ? strlen(stInitParam.pstrPeerId) : 0;

    stInitParam.pstrGUID = env->GetStringUTFChars(guid, NULL);
    stInitParam.nGUIDSize = (NULL != stInitParam.pstrGUID) ? strlen(stInitParam.pstrGUID) : 0;

    stInitParam.pstrStatSavePath = env->GetStringUTFChars(statSavePath, NULL);
    stInitParam.nStatSavePathSize = (NULL != stInitParam.pstrStatSavePath) ? strlen(stInitParam.pstrStatSavePath) : 0;

    stInitParam.pstrStatCfgSavePath = env->GetStringUTFChars(statCfgSavePath, NULL);
    stInitParam.nStatCfgSavePathSize = (NULL != stInitParam.pstrStatCfgSavePath) ? strlen(stInitParam.pstrStatCfgSavePath) : 0;

    stInitParam.net = (NetWorkType)netType;
    stInitParam.nDataBufferSize = dataBufferSize;

    ANDROID_DEBUG_LOG("function %s stInitParam, appKey = %s, appName = %s, appVersion = %s, reservedField = %s, statSavePath = %s, statCfgSavePath = %s, netType = %d, dataBufferType = %d",
    				   __FUNCTION__, stInitParam.pstrAppKey, stInitParam.pstrAppName, stInitParam.pstrAppVersion, stInitParam.pstrReservedField,
					   stInitParam.pstrStatSavePath, stInitParam.pstrStatCfgSavePath, stInitParam.net, stInitParam.nDataBufferSize);

    jint ret = XLInit(&stInitParam);

    /*
     * release memory
     */

    if (NULL != reservedField) {
    	releaseString(reservedField,  stInitParam.pstrReservedField);
    }
    releaseString(appKey,  stInitParam.pstrAppKey);
	releaseString(appName, stInitParam.pstrAppName);
	releaseString(appVersion,  stInitParam.pstrAppVersion);
    releaseString(peerId,  stInitParam.pstrPeerId);
    releaseString(guid,  stInitParam.pstrGUID);
    releaseString(statSavePath,  stInitParam.pstrStatSavePath);
    releaseString(statCfgSavePath,  stInitParam.pstrStatCfgSavePath);

    ANDROID_DEBUG_LOG("function %s end, ret = %d", __FUNCTION__, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    unInit
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_unInit
  (JNIEnv *env, jobject obj)
{
    jint ret = XLUnInit();

    ANDROID_DEBUG_LOG("function %s end, ret = %d", __FUNCTION__, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    notifyNetWorkType
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_notifyNetWorkType
  (JNIEnv *env, jobject obj, jint netType)
{
    jint ret = XLNotifyNetWorkType((NetWorkType)netType);

    ANDROID_DEBUG_LOG("function %s end, networkType = %d, ret = %d", __FUNCTION__, netType, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    createP2spTask
 * Signature: (Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IILcom/xunlei/downloadlib/parameter/GetTaskId;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_createP2spTask(
        JNIEnv *env, jobject obj, jstring url, jstring refUrl, jstring cookie, jstring user, jstring pass,
		jstring filePath, jstring fileName, jint createMode, jint seqId, jobject taskIdObj)
{
    TaskParam stTaskParam;
    stTaskParam.mode = (XL_CREATE_TASK_MODE)createMode;
    stTaskParam.nSeqId = seqId;

    stTaskParam.pstrUrl = env->GetStringUTFChars(url, NULL);
    stTaskParam.nUrlSize = (NULL != stTaskParam.pstrUrl) ? strlen(stTaskParam.pstrUrl) : 0;

    stTaskParam.pstrRefUrl = env->GetStringUTFChars(refUrl, NULL);
    stTaskParam.nRefUrlSize = (NULL != stTaskParam.pstrRefUrl) ? strlen(stTaskParam.pstrRefUrl) : 0;

    stTaskParam.pstrCookie = env->GetStringUTFChars(cookie, NULL);
    stTaskParam.nCookieSize = (NULL != stTaskParam.pstrCookie) ? strlen(stTaskParam.pstrCookie) : 0;

    stTaskParam.pstrUser = env->GetStringUTFChars(user, NULL);
    stTaskParam.nUserSize = (NULL != stTaskParam.pstrUser) ? strlen(stTaskParam.pstrUser) : 0;

    stTaskParam.pstrPass = env->GetStringUTFChars(pass, NULL);
    stTaskParam.nPassSize = (NULL != stTaskParam.pstrPass) ? strlen(stTaskParam.pstrPass) : 0;

    stTaskParam.pstrFilePath = env->GetStringUTFChars(filePath, NULL);
    stTaskParam.nFilePathSize = (NULL != stTaskParam.pstrFilePath) ? strlen(stTaskParam.pstrFilePath) : 0;

    stTaskParam.pstrFilename = env->GetStringUTFChars(fileName, NULL);
    stTaskParam.nFilenameSize = (NULL != stTaskParam.pstrFilename) ? strlen(stTaskParam.pstrFilename) : 0;

    ANDROID_DEBUG_LOG("function %s stTaskParam, url = %s, refUrl = %s, cookie = %s, user = %s, pass = %s, filePath = %s, fileName = %s, createMode = %d, seqId = %d",
    				  __FUNCTION__, stTaskParam.pstrUrl, stTaskParam.pstrRefUrl, stTaskParam.pstrCookie, stTaskParam.pstrUser, stTaskParam.pstrPass, stTaskParam.pstrFilePath,
					  stTaskParam.pstrFilename, createMode, seqId);

    uint64_t taskId = -1;
    jint ret = XLCreateP2spTask(&stTaskParam, &taskId);

    jclass cls = env->GetObjectClass(taskIdObj);
    if (NULL == cls) {
        ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get class taskIdObj error!", __FUNCTION__, taskId);
        //
        /*
         * release memory
         */
        releaseString(url,  stTaskParam.pstrUrl);
        releaseString(refUrl,  stTaskParam.pstrRefUrl);
        releaseString(cookie,  stTaskParam.pstrCookie);
        releaseString(user,  stTaskParam.pstrUser);
        releaseString(pass,  stTaskParam.pstrPass);
        releaseString(filePath,  stTaskParam.pstrFilePath);
        releaseString(fileName,  stTaskParam.pstrFilename);
        return  XL_JNI_ERROR;
    }

    jfieldID field = env->GetFieldID(cls, "mTaskId", "J");
    if (field == NULL) {
        ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get field error!", __FUNCTION__, taskId);
        /*
         * release memory
         */
        releaseString(url,  stTaskParam.pstrUrl);
        releaseString(refUrl,  stTaskParam.pstrRefUrl);
        releaseString(cookie,  stTaskParam.pstrCookie);
        releaseString(user,  stTaskParam.pstrUser);
        releaseString(pass,  stTaskParam.pstrPass);
        releaseString(filePath,  stTaskParam.pstrFilePath);
        releaseString(fileName,  stTaskParam.pstrFilename);
        env->DeleteLocalRef(cls);
        return XL_JNI_ERROR;
    }
    env->SetLongField(taskIdObj, field, taskId);

    /*
     * release memory
     */
    releaseString(url,  stTaskParam.pstrUrl);
    releaseString(refUrl,  stTaskParam.pstrRefUrl);
    releaseString(cookie,  stTaskParam.pstrCookie);
    releaseString(user,  stTaskParam.pstrUser);
    releaseString(pass,  stTaskParam.pstrPass);
    releaseString(filePath,  stTaskParam.pstrFilePath);
    releaseString(fileName,  stTaskParam.pstrFilename);
    env->DeleteLocalRef(cls);

    ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    createHlsTask
 * Signature: (Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IILcom/xunlei/downloadlib/parameter/GetTaskId;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_createHlsTask
  (JNIEnv *env, jobject obj, jstring url, jstring filePath, jstring fileName, jint createMode, jint seqId, jobject taskIdObj)
{
	TaskParamHls stTaskParamHls;

	stTaskParamHls.mode = (XL_CREATE_TASK_MODE)createMode;
	stTaskParamHls.nSeqId = seqId;

	stTaskParamHls.pstrUrl = env->GetStringUTFChars(url, NULL);
	stTaskParamHls.nUrlSize = (NULL != stTaskParamHls.pstrUrl) ? strlen(stTaskParamHls.pstrUrl) : 0;

	stTaskParamHls.pstrFilePath = env->GetStringUTFChars(filePath, NULL);
	stTaskParamHls.nFilePathSize = (NULL != stTaskParamHls.pstrFilePath) ? strlen(stTaskParamHls.pstrFilePath) : 0;

	stTaskParamHls.pstrFileName = env->GetStringUTFChars(fileName, NULL);
	stTaskParamHls.nFileNameSize = (NULL != stTaskParamHls.pstrFileName) ? strlen(stTaskParamHls.pstrFileName) : 0;

	ANDROID_DEBUG_LOG("function %s stTaskParamHls, url = %s, filePath = %s, fileName = %s, createMode = %d, seqId = %d",
					  __FUNCTION__, stTaskParamHls.pstrUrl, stTaskParamHls.pstrFilePath, stTaskParamHls.pstrFileName,
					  stTaskParamHls.mode, stTaskParamHls.nSeqId);

	uint64_t taskId = -1;
	jint ret = XLCreateHlsTask(&stTaskParamHls, &taskId);

	jclass cls = env->GetObjectClass(taskIdObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get class task_id_obj error!",  __FUNCTION__, taskId);

		releaseString(url, stTaskParamHls.pstrUrl);
		releaseString(filePath, stTaskParamHls.pstrFilePath);
		releaseString(fileName, stTaskParamHls.pstrFileName);
		return  XL_JNI_ERROR;
	}

	jfieldID field = env->GetFieldID(cls, "mTaskId", "J");
	if (field == NULL) {
		ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get field error!", __FUNCTION__, taskId);

		releaseString(url, stTaskParamHls.pstrUrl);
		releaseString(filePath, stTaskParamHls.pstrFilePath);
		releaseString(fileName, stTaskParamHls.pstrFileName);
		env->DeleteLocalRef(cls);
		return XL_JNI_ERROR;
	}
	env->SetLongField(taskIdObj, field, taskId);

	releaseString(url, stTaskParamHls.pstrUrl);
	releaseString(filePath, stTaskParamHls.pstrFilePath);
	releaseString(fileName, stTaskParamHls.pstrFileName);
	env->DeleteLocalRef(cls);

	ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    releaseTask
 * Signature: (J)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_releaseTask
  (JNIEnv *env, jobject obj, jlong taskId)
{
    jint ret = XLReleaseTask(taskId);

    ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setTaskAppInfo
 * Signature: (JLjava/lang/String;Ljava/lang/String;Ljava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setTaskAppInfo
  (JNIEnv *env, jobject obj, jlong taskId, jstring appKey, jstring appName, jstring appVersion)
{
    const char *pAppKey = env->GetStringUTFChars(appKey, NULL);
    const char *pAppName = env->GetStringUTFChars(appName, NULL);
    const char *pAppVersion = env->GetStringUTFChars(appVersion, NULL);

    ANDROID_DEBUG_LOG("function %s, taskId = %llu, appKey = %s, appName = %s, appVersion = %s",
    				   __FUNCTION__, taskId, pAppKey, pAppName, pAppVersion);

    int keySize = (NULL != pAppKey) ? strlen(pAppKey) : 0;
    int nameSize = (NULL != pAppName) ? strlen(pAppName) : 0;
    int versionSize = (NULL != pAppVersion) ? strlen(pAppVersion) : 0;

    jint ret = XLSetTaskAppInfo(taskId, pAppKey, keySize, pAppName, nameSize, pAppVersion, versionSize);

    /*
     * release memory
     */
    releaseString(appKey, pAppKey);
    releaseString(appName, pAppName);
    releaseString(appVersion, pAppVersion);

    ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setTaskAllowUseResource
 * Signature: (JI)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setTaskAllowUseResource
  (JNIEnv *env, jobject obj, jlong taskId, jint sourceType)
{
    jint ret = XLSetTaskAllowUseResource(taskId, (DOWNLOADLIB_RESOURCE_TYPE)sourceType);
    ANDROID_DEBUG_LOG("function %s end, taskId = %llu, sourceType = %d, ret = %d", __FUNCTION__, taskId, sourceType, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setTaskUid
 * Signature: (JI)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setTaskUid
  (JNIEnv *env, jobject obj, jlong taskId, jint uid)
{
    jint ret = XLSetTaskUid(taskId, uid);
    ANDROID_DEBUG_LOG("function %s end, taskId = %llu, uid = %d, ret = %d", __FUNCTION__, taskId, uid, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    startTask
 * Signature: (J)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_startTask
  (JNIEnv *env, jobject obj, jlong taskId)
{
//    ANDROID_DEBUG_LOG("function %s begin", __FUNCTION__);
    jint ret = XLStartTask(taskId);

    ANDROID_DEBUG_LOG("function %s end, taskId = %llu, ret = %d", __FUNCTION__, taskId, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    switchOriginToAllResDownload
 * Signature: (J)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_switchOriginToAllResDownload
  (JNIEnv *env, jobject obj, jlong taskId)
{
    jint ret = XLSwitchOriginToAllResDownload(taskId);

    ANDROID_DEBUG_LOG("function %s end, taskId = %llu, ret = %d", __FUNCTION__, taskId, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    stopTask
 * Signature: (J)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_stopTask
  (JNIEnv *env, jobject obj, jlong taskId)
{
    jint ret = XLStopTask(taskId);

    ANDROID_DEBUG_LOG("function %s end, taskId = %llu, ret = %d", __FUNCTION__, taskId, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    stopTaskWithReason
 * Signature: (JI)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_stopTaskWithReason
  (JNIEnv *env, jobject obj, jlong taskId, jint reasonCode)
{
    jint ret = XLStopTaskWithReason(taskId, reasonCode);

    ANDROID_DEBUG_LOG("function %s end, taskId = %llu, reasonCode = %d, ret = %d", __FUNCTION__, taskId, reasonCode, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    getTaskInfo
 * Signature: (JILcom/xunlei/downloadlib/parameter/XLTaskInfo;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getTaskInfo
  (JNIEnv *env, jobject obj, jlong taskId, jint queryMode, jobject taskInfoObj)
{
	ANDROID_DEBUG_LOG("function %s begin, taskId = %llu, queryMode = %d", __FUNCTION__, taskId, queryMode);

	jclass cls;
	jfieldID field;

	cls = env->GetObjectClass(taskInfoObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, get class taskInfoObj error!", __FUNCTION__);
		return XL_JNI_ERROR;
	}

	XL_TASK_INFO taskinfo;
	memset(&taskinfo, 0, sizeof(XL_TASK_INFO));

	taskinfo.additional_res.p_res_types = new uint32_t[2];
	memset(taskinfo.additional_res.p_res_types, 0, sizeof(uint32_t)*2);

	taskinfo.additional_res.p_infos = new XL_RES_TRANSFER_INFO[2];
	memset(taskinfo.additional_res.p_infos, 0, sizeof(XL_RES_TRANSFER_INFO)*2);

	if (queryMode == 1) {
		taskinfo.additional_res.res_type_count = 2;
		taskinfo.additional_res.p_res_types[0] = XL_JNI_SERVER_RES;
		taskinfo.additional_res.p_res_types[1] = XL_JNI_PEER_RES;
	}

	jint ret = XLGetTaskInfo(taskId, &taskinfo);
	if(XL_NO_ERRNO != ret){
		ANDROID_DEBUG_LOG("function %s end, get taskinfo failed, ret = %d", __FUNCTION__, ret);
		env->DeleteLocalRef(cls);
		return ret;
	}

	ANDROID_DEBUG_LOG(
			"function %s----taskid:%llu, fileSize:%llu, downloadSize:%llu, downloadSpeed:%llu, status:%d, errorcode:%d, queryIndexStatus:%d",
			__FUNCTION__, taskId, taskinfo.file_size, taskinfo.download_size,
			taskinfo.download_speed, taskinfo.status, taskinfo.errno_code,
			taskinfo.query_index_status);

	field = env->GetFieldID(cls, "mInfoLen", "I");
	if (field == NULL) {
		ANDROID_DEBUG_LOG("function %s end, get field error!", __FUNCTION__);
		env->DeleteLocalRef(cls);
		return ret;
	}

	env->SetIntField(taskInfoObj, field, taskinfo.len);

	field = env->GetFieldID(cls, "mTaskId", "J");
	env->SetLongField(taskInfoObj, field, taskId);

	field = env->GetFieldID(cls, "mAdditionalResCount", "I");
	env->SetIntField(taskInfoObj, field, 2);

	field = env->GetFieldID(cls, "mTaskStatus", "I");
	env->SetIntField(taskInfoObj, field, taskinfo.status);

	field = env->GetFieldID(cls, "mErrorCode", "I");
	env->SetIntField(taskInfoObj, field, taskinfo.errno_code);

	field = env->GetFieldID(cls, "mFileSize", "J");
	env->SetLongField(taskInfoObj, field, taskinfo.file_size);

	field = (env)->GetFieldID(cls, "mDownloadSize", "J");
	env->SetLongField(taskInfoObj, field, taskinfo.download_size);

	field = env->GetFieldID(cls, "mDownloadSpeed", "J");
	env->SetLongField(taskInfoObj, field, taskinfo.download_speed);

	field = env->GetFieldID(cls, "mQueryIndexStatus", "I");
	env->SetIntField(taskInfoObj, field, taskinfo.query_index_status);

	// set String mCid
	jstring jsCid;
	char *tempHex = (char *) malloc(20 * 2 + 1);
	if (taskinfo.query_index_status == QIS_QUERY_HAVE_INFO) {
		bin2hex(taskinfo.cid, 20, tempHex);
		jsCid = env->NewStringUTF(tempHex);
	} else {
		jsCid = env->NewStringUTF("");
	}
	field = env->GetFieldID(cls, "mCid", "Ljava/lang/String;");
	env->SetObjectField(taskInfoObj, field, jsCid);

	// set String mGcid
	jstring jsGcid;
	if (taskinfo.query_index_status == QIS_QUERY_HAVE_INFO) {
		bin2hex(taskinfo.gcid, 20, tempHex);
		jsGcid = env->NewStringUTF(tempHex);
	} else {
		jsGcid = env->NewStringUTF("");
	}
	field = env->GetFieldID(cls, "mGcid", "Ljava/lang/String;");
	env->SetObjectField(taskInfoObj, field, jsGcid);
	free(tempHex);

	field = (env)->GetFieldID(cls, "mDownloadSize", "J");
	env->SetLongField(taskInfoObj, field, taskinfo.download_size);

	field = env->GetFieldID(cls, "mOriginSpeed", "J");
	env->SetLongField(taskInfoObj, field, taskinfo.origin.speed);
	field = env->GetFieldID(cls, "mOriginRecvBytes", "J");
	env->SetLongField(taskInfoObj, field, taskinfo.origin.recv_bytes);

	field = env->GetFieldID(cls, "mP2SSpeed", "J");
	env->SetLongField(taskInfoObj, field, taskinfo.p2s.speed);
	field = env->GetFieldID(cls, "mP2SRecvBytes", "J");
	env->SetLongField(taskInfoObj, field, taskinfo.p2s.recv_bytes);

	field = env->GetFieldID(cls, "mP2PSpeed", "J");
	env->SetLongField(taskInfoObj, field, taskinfo.p2p.speed);
	field = env->GetFieldID(cls, "mP2PRecvBytes", "J");
	env->SetLongField(taskInfoObj, field, taskinfo.p2p.recv_bytes);

	int i = 0;
	long vipSpeed = (taskinfo.additional_res.p_infos + i)->speed;
	field = env->GetFieldID(cls, "mAdditionalResVipSpeed", "J");
	env->SetLongField(taskInfoObj, field, vipSpeed);

	long vipRecvBytes = (taskinfo.additional_res.p_infos + i)->recv_bytes;
	field = env->GetFieldID(cls, "mAdditionalResVipRecvBytes", "J");
	env->SetLongField(taskInfoObj, field, vipRecvBytes);

	i++;
	long offlineSpeed = (taskinfo.additional_res.p_infos + i)->speed;
	field = env->GetFieldID(cls, "mAdditionalResPeerSpeed", "J");
	env->SetLongField(taskInfoObj, field, offlineSpeed);

	long offlineBytes = (taskinfo.additional_res.p_infos + i)->recv_bytes;
	field = env->GetFieldID(cls, "mAdditionalResPeerBytes", "J");
	env->SetLongField(taskInfoObj, field, offlineBytes);

	ANDROID_DEBUG_LOG("function %s begin ------------vipSpeed=%lu, vipRecvBytes=%lu, PeerSpeed=%lu, PeerBytes=%lu",
			__FUNCTION__, vipSpeed, vipRecvBytes, offlineSpeed, offlineBytes);

	ANDROID_DEBUG_LOG("function %s end, taskId = %llu, ret = %d", __FUNCTION__, taskId, ret);

	delete[] taskinfo.additional_res.p_res_types;
	delete[] taskinfo.additional_res.p_infos;

	env->DeleteLocalRef(cls);
	env->DeleteLocalRef(jsCid);
	env->DeleteLocalRef(jsGcid);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    getTaskInfoEx
 * Signature: (JILcom/xunlei/downloadlib/parameter/XLTaskInfoEx;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getTaskInfoEx
  (JNIEnv *env, jobject obj, jlong taskId, jobject taskInfoExObj)
{
	ANDROID_DEBUG_LOG("Java_com_xunlei_downloadlib_XLLoader_getTaskInfoEx beg, taskId=[%llu] taskInfoExObj=[%p] env=[%p]",
			taskId, taskInfoExObj, env);

	XL_TASK_INFO_EX taskinfoex = {sizeof(taskinfoex)};

	jint ret = XLGetTaskInfoEx(taskId, &taskinfoex);
	if(XL_NO_ERRNO != ret){
		ANDROID_DEBUG_LOG("Java_com_xunlei_downloadlib_XLLoader_getTaskInfoEx XLGetTaskInfoEx failed, taskId=[%llu] taskInfoExObj=[%p] ret=[%d]",
				taskId, taskInfoExObj, ret);
		return ret;
	}

	ANDROID_DEBUG_LOG(
			"Java_com_xunlei_downloadlib_XLLoader_getTaskInfoEx XLGetTaskInfoEx succeed, errno_code=[%d] "
			"p2s_used_total=[%u] p2p_used_total=[%u] p2s_abandon_total=[%u] p2p_abandon_total=[%u] origin_res_state=[%d]",
			taskinfoex.errno_code, taskinfoex.p2s_used_total, taskinfoex.p2p_used_total, taskinfoex.p2s_abandon_total,
			taskinfoex.p2p_abandon_total, taskinfoex.origin_res_state);

	jclass cls;
	jfieldID field;

	cls = env->GetObjectClass(taskInfoExObj);
	if (NULL == cls) {
		ANDROID_ERROR_LOG("Java_com_xunlei_downloadlib_XLLoader_getTaskInfoEx GetObjectClass taskInfoExObj failed, taskId=[%llu] taskInfoExObj=[%p]",
				taskId, taskInfoExObj);
		return XL_JNI_ERROR;
	}

	field = env->GetFieldID(cls, "mInfoLen", "I");
	if (field == NULL) {
		ANDROID_DEBUG_LOG("function %s end, get field error!", __FUNCTION__);
		env->DeleteLocalRef(cls);
		return ret;
	}

	env->SetIntField(taskInfoExObj, field, taskinfoex.len);

	field = env->GetFieldID(cls, "mTaskId", "J");
	env->SetLongField(taskInfoExObj, field, taskId);

	field = env->GetFieldID(cls, "mErrorCode", "I");
	env->SetIntField(taskInfoExObj, field, taskinfoex.errno_code);

	field = env->GetFieldID(cls, "mP2sUsedTotal", "I");
	env->SetIntField(taskInfoExObj, field, taskinfoex.p2s_used_total);

	field = env->GetFieldID(cls, "mP2pUsedTotal", "I");
	env->SetIntField(taskInfoExObj, field, taskinfoex.p2p_used_total);

	field = env->GetFieldID(cls, "mP2sAbandonTotal", "I");
	env->SetIntField(taskInfoExObj, field, taskinfoex.p2s_abandon_total);

	field = env->GetFieldID(cls, "mP2pAbandonTotal", "I");
	env->SetIntField(taskInfoExObj, field, taskinfoex.p2p_abandon_total);

	field = env->GetFieldID(cls, "mOriginResState", "I");
	env->SetIntField(taskInfoExObj, field, taskinfoex.origin_res_state);

	env->DeleteLocalRef(cls);

	ANDROID_DEBUG_LOG("Java_com_xunlei_downloadlib_XLLoader_getTaskInfoEx end, taskId=[%llu]", taskId);
	return ret;
}

JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getLocalUrl
  (JNIEnv *env, jobject obj, jstring strFileName, jobject objLocalUrl)
{
	const char *szFileName = (char *) env->GetStringUTFChars(strFileName, NULL);
	ANDROID_DEBUG_LOG("Java_com_xunlei_downloadlib_XLLoader_getTaskLocalUrl beg, szFileName=[%s]", szFileName);
	char szUrl[4096] = {0};
	int nErrno = XLGetLocalUrl(szFileName, strlen(szFileName), szUrl, sizeof(szUrl));
	if (XL_NO_ERRNO == nErrno)
	{
		jstring jUrl = strToJstring(env, szUrl);

		jclass cls = env->GetObjectClass(objLocalUrl);
		if (NULL == cls) {
			ANDROID_DEBUG_LOG("function %s end, get class taskInfoObj error! szFileName=[%s]", __FUNCTION__, szFileName);
			return XL_JNI_ERROR;
		}

		jfieldID field = env->GetFieldID(cls, "mStrUrl", "Ljava/lang/String;");
		env->SetObjectField(objLocalUrl, field, jUrl);
	}

	ANDROID_DEBUG_LOG("Java_com_xunlei_downloadlib_XLLoader_getTaskLocalUrl end, szFileName=[%s] nErrno=[%d] szUrl=[%s]",
			szFileName, nErrno, szUrl);

	releaseString(strFileName, szFileName);
	return nErrno;
}
/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    addServerResource
 * Signature: (JLjava/lang/String;Ljava/lang/String;Ljava/lang/String;II)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_addServerResource(
        JNIEnv *env, jobject obj, jlong taskId, jstring url, jstring refUrl,
		jstring cookie, jint resType, jint strategy)
{
    char *pUrl = (char *) env->GetStringUTFChars(url, NULL);
    char *pRefUrl = (char *) env->GetStringUTFChars(refUrl, NULL);
    char *pCookie = (char *) env->GetStringUTFChars(cookie, NULL);

    ANDROID_DEBUG_LOG("function %s, taskId = %llu, url = %s, refUrl = %s, cookie = %s, resType = %d, strategy = %d",
    				  __FUNCTION__, taskId, pUrl, pRefUrl, pCookie, resType, strategy);

    resType = XL_JNI_SERVER_RES;	//忽略上层设置的类型值，统一由JNI层维护，避免添加和查询的类型取值不对称

    int urlSize = (NULL != pUrl) ? strlen(pUrl) : 0;
    int refUrlSize = (NULL != pRefUrl) ? strlen(pRefUrl) : 0;
    int cookieSize = (NULL != pCookie) ? strlen(pCookie) : 0;

    jint ret = XLAddServerResource(taskId, urlSize, pUrl, refUrlSize, pRefUrl,
    		cookieSize, pCookie, resType, (RES_USE_STRATEGY) strategy);

    /*
     * release memory
     */
    releaseString(url, pUrl);
    releaseString(refUrl, pRefUrl);
    releaseString(cookie, pCookie);

    ANDROID_DEBUG_LOG("function %s end, taskId = %llu, ret = %d", __FUNCTION__, taskId, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    addPeerResource
 * Signature: (JLjava/lang/String;JLjava/lang/String;Ljava/lang/String;IIIIIII)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_addPeerResource
(JNIEnv *env, jobject obj, jlong taskId, jstring peerID, jlong userId, jstring jmpKey, jstring vipCdnAuth,
		  jint internalIp, jint tcpPort, jint udpPort, jint resLevel, jint resPriority, jint capabilityFlag, jint resType)
{
	char *pPeerID = (char *) env->GetStringUTFChars(peerID, NULL);
	char *pJmpKey = (char *) env->GetStringUTFChars(jmpKey, NULL);
	char *pVipCdnAuth = (char *) env->GetStringUTFChars(vipCdnAuth, NULL);

	ANDROID_DEBUG_LOG("function %s, taskId = %llu, peerID = %s, userId = %llu, jmpKey = %s, vipCdnAuth = %s, "
			"internalIp = %d, tcpPort = %d, udpPort = %d, resLevel  = %d, resPriority = %d, capabilityFlag = %d, appDefinedType = %d",
			__FUNCTION__, taskId, pPeerID, userId, pJmpKey, pVipCdnAuth, internalIp, tcpPort, udpPort, resLevel, resPriority, capabilityFlag, resType);

	resType = XL_JNI_PEER_RES;	//忽略上层设置的类型值，统一由JNI层维护，避免添加和查询的类型取值不对称

	int peerIDSize = (NULL != pPeerID) ? strlen(pPeerID) : 0;
	int jmpKeySize = (NULL != pJmpKey) ? strlen(pJmpKey) : 0;
	int vipCdnAuthSize = (NULL != pVipCdnAuth) ? strlen(pVipCdnAuth) : 0;

	jint ret = XLAddPeerResource(taskId, pPeerID, peerIDSize, userId, pJmpKey, jmpKeySize, pVipCdnAuth, vipCdnAuthSize,
			internalIp, tcpPort, udpPort, resLevel, resPriority, capabilityFlag, resType);

	/*
	 * release memory
	 */
	releaseString(peerID, pPeerID);
	releaseString(jmpKey, pJmpKey);
	releaseString(vipCdnAuth, pVipCdnAuth);

	ANDROID_DEBUG_LOG("function %s end, taskId = %llu, ret = %d", __FUNCTION__, taskId, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    removeAddedServerResource
 * Signature: (JI)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_removeAddedServerResource
  (JNIEnv *env, jobject obj, jlong taskId, jint resType)
{
    jint ret = XLRemoveAddedResource(taskId, resType);
    ANDROID_DEBUG_LOG("function %s end, taskId = %llu, resType = %d, ret = %d", __FUNCTION__, taskId, resType, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    requeryIndex
 * Signature: (J)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_requeryIndex
  (JNIEnv *env, jobject obj, jlong taskId)
{
    jint ret = XLRequeryIndex(taskId);
    ANDROID_DEBUG_LOG("function %s end, taskId = %llu, ret = %d", __FUNCTION__, taskId, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setOriginUserAgent
 * Signature: (JLjava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setOriginUserAgent
  (JNIEnv *env, jobject obj, jlong taskId, jstring userAgent)
{
	jint ret;
	const char *pUserAgent = env->GetStringUTFChars(userAgent, NULL);
	int size = (NULL != pUserAgent) ? strlen(pUserAgent) : 0;

	ret = XLSetOriginUserAgent(taskId, pUserAgent, size);
	ANDROID_DEBUG_LOG("function %s end, taskId = %llu, userAgent = %s, ret = %d", __FUNCTION__, taskId, pUserAgent, ret);

	releaseString(userAgent, pUserAgent);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setHttpHeaderProperty
 * Signature: (JLjava/lang/String;Ljava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setHttpHeaderProperty
  (JNIEnv *env, jobject obj, jlong taskId, jstring name, jstring value)
{
	jint ret;
	const char *pName = env->GetStringUTFChars(name, NULL);
    const char *pValue =  env->GetStringUTFChars(value, NULL);
    int nameSize = (NULL != pName) ? strlen(pName) : 0;
    int valueSize = (NULL != pValue) ? strlen(pValue) : 0;

	ret = XLSetHttpHeaderProperty(taskId, pName, nameSize, pValue, valueSize);

	ANDROID_DEBUG_LOG("function %s end, name = %s, value = %s, taskId = %llu, ret = %d",
			__FUNCTION__, pName, pValue, taskId, ret);

	releaseString(name, pName);
	releaseString(value, pValue);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setUserId
 * Signature: (Ljava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setUserId
  (JNIEnv *env, jobject obj, jstring userId)
{
	jint ret;
	const char *pUserId = env->GetStringUTFChars(userId, NULL);
	int size = (NULL != pUserId) ? strlen(pUserId) : 0;

	ret = XLSetUserId(pUserId, size);
	ANDROID_DEBUG_LOG("function %s end, userId=%s, ret = %d", __FUNCTION__, pUserId, ret);

	releaseString(userId, pUserId);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    getDownloadHeader
 * Signature: (JLcom/xunlei/downloadlib/parameter/GetDownloadHead;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getDownloadHeader
  (JNIEnv *env, jobject obj, jlong taskId, jobject downloadHeadObj)
{
	jclass cls;
	jfieldID field;

	cls = env->GetObjectClass(downloadHeadObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, taskId = %llu, get class downloadHeadObj error!", __FUNCTION__, taskId);
		return XL_JNI_ERROR;
	}

	DownloadHeader header;
	memset(header.downloadHeader, 0, MAX_HEADER_LEN);
	header.state = GDHS_UNKOWN;
	jint ret = XLGetDownloadHeader(taskId, &header);
	if(XL_NO_ERRNO != ret){
		ANDROID_DEBUG_LOG("function %s end, GetDownloadHeader failed, ret = %d", __FUNCTION__, ret);
		env->DeleteLocalRef(cls);
		return ret;
	}

	field = env->GetFieldID(cls, "mHttpState", "I");
	env->SetIntField(downloadHeadObj, field, header.state);

	jstring jsHttpResponse;
	if (header.downloadHeader[0] == '\0') {
		jsHttpResponse = env->NewStringUTF("");
	} else {
		jsHttpResponse = strToJstring(env,header.downloadHeader);
	}
	field = env->GetFieldID(cls, "mHttpResponse", "Ljava/lang/String;");
	env->SetObjectField(downloadHeadObj, field, jsHttpResponse);

	ANDROID_DEBUG_LOG("function %s end, taskId = %llu, ret = %d, header.state = %d, response = %s",
			__FUNCTION__, taskId, ret, header.state, header.downloadHeader);

	env->DeleteLocalRef(cls);
	env->DeleteLocalRef(jsHttpResponse);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setFileName
 * Signature: (JLjava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setFileName
  (JNIEnv *env, jobject obj, jlong taskId, jstring fileName)
{
	jint ret;
	const char *pFileName = env->GetStringUTFChars(fileName, NULL);
	int size = (NULL != pFileName) ? strlen(pFileName) : 0;

	ret = XLSetFileName(taskId, pFileName, size);
	ANDROID_DEBUG_LOG("function %s end, taskId = %llu, fileName = %s, ret = %d",
			__FUNCTION__, taskId, pFileName, ret);

	releaseString(fileName, pFileName);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setNotifyNetWorkCarrier
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setNotifyNetWorkCarrier
  (JNIEnv *env, jobject obj, jint carrier)
{
	jint ret = XLNotifyNetWorkCarrier((NetWorkCarrier)carrier);
	ANDROID_DEBUG_LOG("function %s end, carrier = %d, ret = %d", __FUNCTION__, carrier, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setNotifyWifiBSSID
 * Signature: (Ljava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setNotifyWifiBSSID
  (JNIEnv *env, jobject obj, jstring bssid)
{
    const char *pBSSID = env->GetStringUTFChars(bssid, NULL);
    int size = (NULL != pBSSID) ? strlen(pBSSID) : 0;

    jint ret = XLNotifyWifiBSSID(pBSSID, size);

    ANDROID_DEBUG_LOG("function %s end, ret = %d", __FUNCTION__, ret);
    releaseString(bssid, pBSSID);

    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setDownloadTaskOrigin
 * Signature: (JLjava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setDownloadTaskOrigin
  (JNIEnv *env , jobject obj, jlong taskId, jstring taskOrigin)
{
	jint ret;
	const char *pTaskOrigin = env->GetStringUTFChars(taskOrigin, NULL);
	int size = (NULL != pTaskOrigin) ? strlen(pTaskOrigin) : 0;

	ret = XLSetDownloadTaskOrigin(taskId, pTaskOrigin, size);
	ANDROID_DEBUG_LOG("function %s end, taskOrigin = %s, taskId = %llu, ret = %d\n",
			__FUNCTION__, pTaskOrigin, taskId, ret);

	releaseString(taskOrigin, pTaskOrigin);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setMac
 * Signature: (Ljava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setMac
  (JNIEnv *env, jobject obj, jstring mac)
{
	jint ret;
	const char *pMac = env->GetStringUTFChars(mac, NULL);
	int size = (NULL != pMac) ? strlen(pMac) : 0;

	ret = XLSetMac(pMac, size);
	ANDROID_DEBUG_LOG("function %s end, mac = %s, ret = %d\n", __FUNCTION__, pMac, ret);

	releaseString(mac, pMac);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setImei
 * Signature: (Ljava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setImei
  (JNIEnv *env, jobject obj, jstring imei)
{
	jint ret;
	const char *pImei = env->GetStringUTFChars(imei, NULL);
	int size = (NULL != pImei) ? strlen(pImei) : 0;

	ret = XLSetImei(pImei, size);
	ANDROID_DEBUG_LOG("function %s end, imei = %s, ret = %d\n", __FUNCTION__, pImei, ret);

	releaseString(imei, pImei);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setLocalProperty
 * Signature: (Ljava/lang/String;Ljava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setLocalProperty
  (JNIEnv *env, jobject obj, jstring key, jstring value)
{
	jint ret;
	const char *pKey = env->GetStringUTFChars(key, NULL);
	const char *pValue = env->GetStringUTFChars(value, NULL);
	int keySize = (NULL != pKey) ? strlen(pKey) : 0;
	int valueSize = (NULL != pValue) ? strlen(pValue) : 0;

	ret = XLSetLocalProperty(pKey, keySize, pValue, valueSize);
	ANDROID_DEBUG_LOG("function %s end, key = %s, value = %s, ret = %d\n",
			__FUNCTION__, pKey, pValue, ret);

	releaseString(key, pKey);
	releaseString(value, pValue);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setMiUiVersion
 * Signature: (Ljava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setMiUiVersion
  (JNIEnv *env, jobject obj, jstring miuiVersion)
{
	jint ret;
	const char *pMiuiVersion = env->GetStringUTFChars(miuiVersion, NULL);
	int size = (NULL != pMiuiVersion) ? strlen(pMiuiVersion) : 0;

	ret = XLSetMiUiVersion(pMiuiVersion, size);
	ANDROID_DEBUG_LOG("function %s end, miuiVersion = %s, ret = %d\n", __FUNCTION__, pMiuiVersion, ret);

	releaseString(miuiVersion, pMiuiVersion);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    getDownloadLibVersion
 * Signature: (Lcom/xunlei/downloadlib/parameter/GetDownloadLibVersion;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getDownloadLibVersion
  (JNIEnv *env, jobject obj, jobject versionObj)
{
	jclass cls = env->GetObjectClass(versionObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, get class versionObj error!", __FUNCTION__);
		return XL_JNI_ERROR;
	}

	jstring jsVersion;
	char *pVersion = (char *)malloc(MAX_VERSION_LEN);

	jint ret = XLGetVersion(pVersion);
	if (ret == XL_NO_ERRNO) {
		jsVersion = strToJstring(env, pVersion);
	} else {
		jsVersion = env->NewStringUTF("");
	}
	jfieldID field = env->GetFieldID(cls, "mVersion", "Ljava/lang/String;");
	env->SetObjectField(versionObj, field, jsVersion);

	ANDROID_DEBUG_LOG("function %s end, version = %s", __FUNCTION__, pVersion);
	env->DeleteLocalRef(jsVersion);
	env->DeleteLocalRef(cls);
	free(pVersion);

	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    enterPrefetchMode
 * Signature: (J)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_enterPrefetchMode
  (JNIEnv *env, jobject obj, jlong taskId)
{
    jint ret = XLEnterPrefetchMode(taskId);

    ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setTaskLxState
 * Signature: (JII)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setTaskLxState
  (JNIEnv *env, jobject obj, jlong taskId, jint subIndex, jint state)
{
    jint ret = XLSetTaskLxState(taskId, subIndex, state);

    ANDROID_DEBUG_LOG("function %s end, taskid = %llu, subIndex = %d, state = %d, ret = %d", __FUNCTION__, taskId, subIndex, state, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setTaskGsState
 * Signature: (JII)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setTaskGsState
  (JNIEnv *env, jobject obj, jlong taskId, jint subIndex, jint state)
{
    jint ret = XLSetTaskGsState(taskId, subIndex, (HIGH_SPEED_CHANNEL_STATE)state);

    ANDROID_DEBUG_LOG("function %s end, taskid = %llu, subIndex = %d, state = %d, ret = %d", __FUNCTION__, taskId, subIndex, state, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setReleaseLog
 * Signature: (ILcom/xunlei/downloadlib/parameter/SetReleaseLogParam;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setReleaseLog
  (JNIEnv *env, jobject obj, jint turnOn, jstring logFilePath, jint logMaxSize, jint logMaxCount)
{
	SetRLogParam releaseLogParam;

	if(NULL != logFilePath){
		releaseLogParam.logFilePath = env->GetStringUTFChars(logFilePath, NULL);
	}else{
		releaseLogParam.logFilePath = "";
	}
	releaseLogParam.pathSize = (NULL != releaseLogParam.logFilePath) ? strlen(releaseLogParam.logFilePath) : 0;

	releaseLogParam.logMaxSize = logMaxSize;
	releaseLogParam.logMaxCount = logMaxCount;

	ANDROID_DEBUG_LOG("function %s begin, turnOn = %d, logFilePath = %s, pathSize = %d, logMaxSize = %d, logMaxCount = %d", __FUNCTION__, turnOn,
			releaseLogParam.logFilePath, releaseLogParam.pathSize, logMaxSize, logMaxCount);

	jint ret = XLSetReleaseLog(turnOn, &releaseLogParam);

	ANDROID_DEBUG_LOG("function %s end, ret = %d", __FUNCTION__, ret);
	if(NULL != logFilePath){
		releaseString(logFilePath,  releaseLogParam.logFilePath);
	}

	return ret;

}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    isLogTurnOn
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_com_xunlei_downloadlib_XLLoader_isLogTurnOn
  (JNIEnv *, jobject)
{
	uint32_t retIsTurnOn = 0;
	jint ret = XLIsLogTurnOn(&retIsTurnOn);
	ANDROID_DEBUG_LOG("function %s ret = %d, retIsTurnOn = %u",__FUNCTION__, ret, retIsTurnOn);
	//如果调用失败，也认定Log是开启的.
	return ((retIsTurnOn!=0||ret!=XL_NO_ERRNO) ? JNI_TRUE : JNI_FALSE);
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    setStatReportSwitch
 * Signature: (Z)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_setStatReportSwitch
  (JNIEnv *env, jobject obj, jboolean reportSwitch)
{
	jint ret = XLSetStatReportSwitch(reportSwitch);
	ANDROID_DEBUG_LOG("function %s ret = %d, reportSwitch = %u",__FUNCTION__, ret, reportSwitch);

	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    createBtMagnetTask
 * Signature: (Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Lcom/xunlei/downloadlib/parameter/GetTaskId;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_createBtMagnetTask
  (JNIEnv *env, jobject obj, jstring url, jstring filePath, jstring fileName, jobject taskIdObj)
{
	TaskParamMagnet stTaskParamMagnet;

	stTaskParamMagnet.pstrUrl = env->GetStringUTFChars(url, NULL);
	stTaskParamMagnet.nUrlSize = (NULL != stTaskParamMagnet.pstrUrl) ? strlen(stTaskParamMagnet.pstrUrl) : 0;

	stTaskParamMagnet.pstrFilePath = env->GetStringUTFChars(filePath, NULL);
	stTaskParamMagnet.nFilePathSize = (NULL != stTaskParamMagnet.pstrFilePath) ? strlen(stTaskParamMagnet.pstrFilePath) : 0;

	stTaskParamMagnet.pstrFileName = env->GetStringUTFChars(fileName, NULL);
	stTaskParamMagnet.nFileNameSize = (NULL != stTaskParamMagnet.pstrFileName) ? strlen(stTaskParamMagnet.pstrFileName) : 0;

    ANDROID_DEBUG_LOG("function %s stTaskParamMagnet, url = %s, filePath = %s, fileName = %s",
    				  __FUNCTION__, stTaskParamMagnet.pstrUrl, stTaskParamMagnet.pstrFilePath, stTaskParamMagnet.pstrFileName);

    uint64_t taskId = -1;
    jint ret = XLCreateBtMagnetTask(&stTaskParamMagnet, &taskId);

    jclass cls = env->GetObjectClass(taskIdObj);
    if (NULL == cls) {
        ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get class taskIdObj error!",  __FUNCTION__, taskId);
        //
        /*
         * release memory
         */
        releaseString(url, stTaskParamMagnet.pstrUrl);
        releaseString(filePath, stTaskParamMagnet.pstrFilePath);
        releaseString(fileName, stTaskParamMagnet.pstrFileName);
        return  XL_JNI_ERROR;
    }

    jfieldID field = env->GetFieldID(cls, "mTaskId", "J");
    if (field == NULL) {
        ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get field error!", __FUNCTION__, taskId);
        /*
         * release memory
         */
        releaseString(url, stTaskParamMagnet.pstrUrl);
        releaseString(filePath, stTaskParamMagnet.pstrFilePath);
        releaseString(fileName, stTaskParamMagnet.pstrFileName);
        env->DeleteLocalRef(cls);
        return XL_JNI_ERROR;
    }
    env->SetLongField(taskIdObj, field, taskId);

    /*
     * release memory
     */
    releaseString(url, stTaskParamMagnet.pstrUrl);
    releaseString(filePath, stTaskParamMagnet.pstrFilePath);
    releaseString(fileName, stTaskParamMagnet.pstrFileName);
    env->DeleteLocalRef(cls);

    ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    createBtTask
 * Signature: (Ljava/lang/String;Ljava/lang/String;IIILcom/xunlei/downloadlib/parameter/GetTaskId;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_createBtTask(
		JNIEnv *env, jobject obj, jstring torrentPath, jstring filePath,
		jint maxConcurrent, jint createMode, jint seqId, jobject taskIdObj)
{
	TaskParamBt stTaskParamBt;

	stTaskParamBt.pstrTorrentPath = env->GetStringUTFChars(torrentPath, NULL);
	stTaskParamBt.nTorrentPathSize = (NULL != stTaskParamBt.pstrTorrentPath) ? strlen(stTaskParamBt.pstrTorrentPath) : 0;

	stTaskParamBt.pstrFilePath = env->GetStringUTFChars(filePath, NULL);
	stTaskParamBt.nFilePathSize = (NULL != stTaskParamBt.pstrFilePath) ? strlen(stTaskParamBt.pstrFilePath) : 0;

	stTaskParamBt.nMaxConcurrent = maxConcurrent;
	stTaskParamBt.mode = (XL_CREATE_TASK_MODE)createMode;
	stTaskParamBt.nSeqId = seqId;

    ANDROID_DEBUG_LOG("function %s stTaskParamBt, torrentPath = %s, filePath = %s, maxConcurrent = %d, createMode = %d, seqId = %d",
    				  __FUNCTION__, stTaskParamBt.pstrTorrentPath, stTaskParamBt.pstrFilePath, maxConcurrent, createMode, seqId);

    uint64_t taskId = -1;
    jint ret = XLCreateBtTask(&stTaskParamBt, &taskId);

    jclass cls = env->GetObjectClass(taskIdObj);
    if (NULL == cls) {
        ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get class taskIdObj error!",  __FUNCTION__, taskId);
        //
        /*
         * release memory
         */
        releaseString(torrentPath, stTaskParamBt.pstrTorrentPath);
        releaseString(filePath, stTaskParamBt.pstrFilePath);
        return  XL_JNI_ERROR;
    }

    jfieldID field = env->GetFieldID(cls, "mTaskId", "J");
    if (field == NULL) {
        ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get field error!", __FUNCTION__, taskId);
        /*
         * release memory
         */
        releaseString(torrentPath, stTaskParamBt.pstrTorrentPath);
        releaseString(filePath, stTaskParamBt.pstrFilePath);
        env->DeleteLocalRef(cls);
        return XL_JNI_ERROR;
    }
    env->SetLongField(taskIdObj, field, taskId);

    /*
     * release memory
     */
    releaseString(torrentPath, stTaskParamBt.pstrTorrentPath);
    releaseString(filePath, stTaskParamBt.pstrFilePath);
    env->DeleteLocalRef(cls);

    ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
    return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    getTorrentInfo
 * Signature: (Ljava/lang/String;Lcom/xunlei/downloadlib/parameter/TorrentInfo;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getTorrentInfo
  (JNIEnv *env, jobject obj, jstring torrentPath, jobject torrentInfoObj)
{
	jclass cls;
	jfieldID field;

	cls = env->GetObjectClass(torrentInfoObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, get class torrentInfoObj error!", __FUNCTION__);
		return XL_JNI_ERROR;
	}

	TorrentInfo torrentInfo;
	memset(&torrentInfo, 0, sizeof(TorrentInfo));
	torrentInfo.countOfSubFileInfoStruct = 0;
	torrentInfo.subFileInfo = NULL;

	jint ret;
	const char *pTorrentPath = env->GetStringUTFChars(torrentPath, NULL);
	int pathSize = (NULL != pTorrentPath) ? strlen(pTorrentPath) : 0;
	ANDROID_DEBUG_LOG("function %s, torrentPath = %s", __FUNCTION__, pTorrentPath);

	ret = XLGetTorrentInfo(pTorrentPath, pathSize, &torrentInfo);
	if (XL_NO_ENOUGH_BUFFER == ret) {
		torrentInfo.countOfSubFileInfoStruct = torrentInfo.fileCount;
		torrentInfo.subFileInfo = new TorrentFileInfo[torrentInfo.fileCount];
		ret = XLGetTorrentInfo(pTorrentPath, pathSize, &torrentInfo);
	}
	releaseString(torrentPath, pTorrentPath);

	if (XL_NO_ERRNO != ret) {
		if (NULL != torrentInfo.subFileInfo)
		{
			delete[] torrentInfo.subFileInfo;
		}
		ANDROID_DEBUG_LOG("function %s end, get torrentInfo failed, ret = %d", __FUNCTION__, ret);
		env->DeleteLocalRef(cls);
		return ret;
	}

	ANDROID_DEBUG_LOG("function %s, fileCount = %d, isMultiFiles = %d, multiFileBaseFolder = %s, countOfSubFileInfoStruct = %d",
			__FUNCTION__, torrentInfo.fileCount, torrentInfo.isMultiFiles,
			torrentInfo.multiFileBaseFolder, torrentInfo.countOfSubFileInfoStruct);

	field = env->GetFieldID(cls, "mFileCount", "I");
	env->SetIntField(torrentInfoObj, field, torrentInfo.fileCount);

	jboolean isMultiFiles = (1 == torrentInfo.isMultiFiles) ? JNI_TRUE : JNI_FALSE;
	field = env->GetFieldID(cls, "mIsMultiFiles", "Z");
	env->SetBooleanField(torrentInfoObj, field, isMultiFiles);

	jstring jsBaseFolder = strToJstring(env, torrentInfo.multiFileBaseFolder);
	field = env->GetFieldID(cls, "mMultiFileBaseFolder", "Ljava/lang/String;");
	env->SetObjectField(torrentInfoObj, field, jsBaseFolder);
	env->DeleteLocalRef(jsBaseFolder);

	char *tempHex = (char *) malloc(INFO_HASH_SIZE * 2 + 1);
	bin2hex(torrentInfo.infoHash, INFO_HASH_SIZE, tempHex);
	ANDROID_DEBUG_LOG("function %s, infoHash = %s", __FUNCTION__, tempHex);
	jstring jsInfoHash = env->NewStringUTF(tempHex);
	field = env->GetFieldID(cls, "mInfoHash", "Ljava/lang/String;");
	env->SetObjectField(torrentInfoObj, field, jsInfoHash);
	env->DeleteLocalRef(jsInfoHash);
	free(tempHex);

	jclass clsFileInfo = env->FindClass("com/xunlei/downloadlib/parameter/TorrentFileInfo");
	jmethodID fileInfoInit = env->GetMethodID(clsFileInfo, "<init>", "()V");
	jobject fileInfoElem = env->NewObject(clsFileInfo, fileInfoInit);
	jobjectArray fileInfoArray = env->NewObjectArray(torrentInfo.countOfSubFileInfoStruct, clsFileInfo, fileInfoElem);
	env->DeleteLocalRef(fileInfoElem);

	jfieldID subPathField = env->GetFieldID(clsFileInfo, "mSubPath", "Ljava/lang/String;");
	jfieldID fileNameField = env->GetFieldID(clsFileInfo, "mFileName", "Ljava/lang/String;");
	jfieldID fileSizeField = env->GetFieldID(clsFileInfo, "mFileSize", "J");
	jfieldID fileIndexField = env->GetFieldID(clsFileInfo, "mFileIndex", "I");
	jfieldID realIndexField = env->GetFieldID(clsFileInfo, "mRealIndex", "I");
	for (jint i = 0; i < torrentInfo.countOfSubFileInfoStruct; i++)
	{
		ANDROID_DEBUG_LOG("function %s, subFileInfo[%d]: fileIndex = %d, fileName = %s, subPath = %s, fileSize = %llu",
					__FUNCTION__, i, torrentInfo.subFileInfo[i].fileIndex, torrentInfo.subFileInfo[i].fileName,
					torrentInfo.subFileInfo[i].subPath, torrentInfo.subFileInfo[i].fileSize);

		fileInfoElem = env->NewObject(clsFileInfo, fileInfoInit);

		jstring jsSubPath = strToJstring(env, torrentInfo.subFileInfo[i].subPath);
		env->SetObjectField(fileInfoElem, subPathField, jsSubPath);
		env->DeleteLocalRef(jsSubPath);

		jstring jsFileName = strToJstring(env, torrentInfo.subFileInfo[i].fileName);
		env->SetObjectField(fileInfoElem, fileNameField, jsFileName);
		env->DeleteLocalRef(jsFileName);

		env->SetLongField(fileInfoElem, fileSizeField, torrentInfo.subFileInfo[i].fileSize);
		env->SetIntField(fileInfoElem, fileIndexField, torrentInfo.subFileInfo[i].fileIndex);
		env->SetIntField(fileInfoElem, realIndexField, torrentInfo.subFileInfo[i].realIndex);

		env->SetObjectArrayElement(fileInfoArray, i, fileInfoElem);
		env->DeleteLocalRef(fileInfoElem);
	}

	field = env->GetFieldID(cls, "mSubFileInfo", "[Lcom/xunlei/downloadlib/parameter/TorrentFileInfo;");
	env->SetObjectField(torrentInfoObj, field, fileInfoArray);
	env->DeleteLocalRef(clsFileInfo);
	env->DeleteLocalRef(fileInfoArray);

	delete[] torrentInfo.subFileInfo;
	env->DeleteLocalRef(cls);
	ANDROID_DEBUG_LOG("function %s end, ret = %d", __FUNCTION__, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    getBtSubTaskStatus
 * Signature: (JLcom/xunlei/downloadlib/parameter/BtTaskStatus;II)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getBtSubTaskStatus
  (JNIEnv *env, jobject obj, jlong taskId, jobject btTaskStatusObj, jint start, jint count)
{
	jclass cls;
	jfieldID field;

	cls = env->GetObjectClass(btTaskStatusObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get class btTaskStatusObj error!", __FUNCTION__, taskId);
		return XL_JNI_ERROR;
	}

	field = env->GetFieldID(cls, "mStatus", "[I");
	jintArray statusArray = (jintArray)env->GetObjectField(btTaskStatusObj, field);
	jsize length = env->GetArrayLength(statusArray);

	jint *status = env->GetIntArrayElements(statusArray, NULL);
	jint ret = XLGetBtSubTaskStatus(taskId, (PBtTaskStatus)status, start, count);

	ANDROID_DEBUG_LOG("function %s, taskid = %llu, start = %d, count = %d",
			__FUNCTION__, taskId, start, count);
#ifdef __ANDROID_LOG__
	for (jint i = start; i < start + count; i++)
	{
		ANDROID_DEBUG_LOG("function %s, taskid = %llu, subTaskStatus[%d] = %d",
				__FUNCTION__, taskId, i, status[i]);
	}
#endif

	env->SetIntArrayRegion(statusArray, 0, length, status);
	env->SetObjectField(btTaskStatusObj, field, statusArray);
	env->ReleaseIntArrayElements(statusArray, status, JNI_ABORT);

	env->DeleteLocalRef(cls);
	env->DeleteLocalRef(statusArray);
	ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    getBtSubTaskInfo
 * Signature: (JILcom/xunlei/downloadlib/parameter/BtSubTaskDetail;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getBtSubTaskInfo
  (JNIEnv *env, jobject obj, jlong taskId, jint fileIndex, jobject subTaskDetailObj)
{
    jclass cls;
    jfieldID field;

    cls = env->GetObjectClass(subTaskDetailObj);
    if (NULL == cls) {
        ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get class subTaskDetailObj error!", __FUNCTION__, taskId);
        return XL_JNI_ERROR;
    }

    BtSubTaskDetail detail;
    memset(&detail, 0, sizeof(BtSubTaskDetail));
    detail.taskInfo.additional_res.res_type_count = 0;

    //if (queryMode == 1) {
    	detail.taskInfo.additional_res.res_type_count = 2;
    	detail.taskInfo.additional_res.p_res_types = new uint32_t[2];
    	detail.taskInfo.additional_res.p_res_types[0] = XL_JNI_SERVER_RES;
    	detail.taskInfo.additional_res.p_res_types[1] = XL_JNI_PEER_RES;
    	detail.taskInfo.additional_res.p_infos = new XL_RES_TRANSFER_INFO[2];
    	//memset(detail.taskInfo.additional_res.p_infos, 0, sizeof(XL_RES_TRANSFER_INFO)*2);
    //}

    jint ret = XLGetBtSubTaskInfo(taskId, fileIndex, &detail);
    if (XL_NO_ERRNO != ret) {
    	ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get detail failed, ret = %d", __FUNCTION__, taskId, ret);
    	env->DeleteLocalRef(cls);
    	return ret;
    }

    ANDROID_DEBUG_LOG("function %s, taskid = %llu, fileIndex = %d, isSelect = %d, status = %d, errorCode = %d, "
    		"infoLen = %d, fileSize = %llu, downloadSize = %llu, downloadSpeed = %llu, "
    		"queryIndexStatus = %d, originSpeed = %llu, originRecvBytes = %llu, "
    		"p2sSpeed = %llu, p2sRecvBytes = %llu, "
    		"p2pSpeed = %llu, p2pRecvBytes = %llu",
    		__FUNCTION__, taskId, detail.fileIndex, detail.isSelect, detail.taskInfo.status, detail.taskInfo.errno_code,
			detail.taskInfo.len, detail.taskInfo.file_size, detail.taskInfo.download_size, detail.taskInfo.download_speed,
			detail.taskInfo.query_index_status, detail.taskInfo.origin.speed, detail.taskInfo.origin.recv_bytes,
			detail.taskInfo.p2s.speed, detail.taskInfo.p2s.recv_bytes,
			detail.taskInfo.p2p.speed, detail.taskInfo.p2p.recv_bytes);

    field = env->GetFieldID(cls, "mFileIndex", "I");
    env->SetIntField(subTaskDetailObj, field, detail.fileIndex);

    field = env->GetFieldID(cls, "mIsSelect", "Z");
    env->SetBooleanField(subTaskDetailObj, field, detail.isSelect);

    field = env->GetFieldID(cls, "mTaskInfo", "Lcom/xunlei/downloadlib/parameter/XLTaskInfo;");
    jobject taskInfo = env->GetObjectField(subTaskDetailObj, field);
    if (NULL == taskInfo) {
        ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get obj taskInfo error!", __FUNCTION__, taskId);
        env->DeleteLocalRef(cls);
        return XL_JNI_ERROR;
    }

    jclass clsInfo = env->FindClass("com/xunlei/downloadlib/parameter/XLTaskInfo");
    if (NULL == clsInfo) {
        ANDROID_DEBUG_LOG("function %s end, taskid = %llu, find class XLTaskInfo error!", __FUNCTION__, taskId);
        env->DeleteLocalRef(cls);
        env->DeleteLocalRef(taskInfo);
        return XL_JNI_ERROR;
    }

    jfieldID fieldInfo;

    fieldInfo = env->GetFieldID(clsInfo, "mTaskId", "J");
    env->SetLongField(taskInfo, fieldInfo, taskId);

    fieldInfo = env->GetFieldID(clsInfo, "mInfoLen", "I");
    env->SetIntField(taskInfo, fieldInfo, detail.taskInfo.len);

    fieldInfo = env->GetFieldID(clsInfo, "mTaskStatus", "I");
    env->SetIntField(taskInfo, fieldInfo, detail.taskInfo.status);

    fieldInfo = env->GetFieldID(clsInfo, "mErrorCode", "I");
    env->SetIntField(taskInfo, fieldInfo, detail.taskInfo.errno_code);

    fieldInfo = env->GetFieldID(clsInfo, "mFileSize", "J");
    env->SetLongField(taskInfo, fieldInfo, detail.taskInfo.file_size);

    fieldInfo = env->GetFieldID(clsInfo, "mDownloadSize", "J");
    env->SetLongField(taskInfo, fieldInfo, detail.taskInfo.download_size);

    fieldInfo = env->GetFieldID(clsInfo, "mDownloadSpeed", "J");
    env->SetLongField(taskInfo, fieldInfo, detail.taskInfo.download_speed);

    fieldInfo = env->GetFieldID(clsInfo, "mQueryIndexStatus", "I");
    env->SetIntField(taskInfo, fieldInfo, detail.taskInfo.query_index_status);

    char *tempHex = (char *) malloc(20 * 2 + 1);

    // set String mCid
    jstring jsCid;
    if (detail.taskInfo.query_index_status == QIS_QUERY_HAVE_INFO) {
    	bin2hex(detail.taskInfo.cid, 20, tempHex);
        jsCid = env->NewStringUTF(tempHex);
    } else {
        jsCid = env->NewStringUTF("");
    }
    fieldInfo = env->GetFieldID(clsInfo, "mCid", "Ljava/lang/String;");
    env->SetObjectField(taskInfo, fieldInfo, jsCid);
    env->DeleteLocalRef(jsCid);

    // set String mGcid
	jstring jsGcid;
	if (detail.taskInfo.query_index_status == QIS_QUERY_HAVE_INFO) {
		bin2hex(detail.taskInfo.gcid, 20, tempHex);
		jsGcid = env->NewStringUTF(tempHex);
	} else {
		jsGcid = env->NewStringUTF("");
	}
	fieldInfo = env->GetFieldID(clsInfo, "mGcid", "Ljava/lang/String;");
	env->SetObjectField(taskInfo, fieldInfo, jsGcid);
	env->DeleteLocalRef(jsGcid);

	free(tempHex);

    fieldInfo = env->GetFieldID(clsInfo, "mOriginSpeed", "J");
    env->SetLongField(taskInfo, fieldInfo, detail.taskInfo.origin.speed);

    fieldInfo = env->GetFieldID(clsInfo, "mOriginRecvBytes", "J");
    env->SetLongField(taskInfo, fieldInfo, detail.taskInfo.origin.recv_bytes);

    fieldInfo = env->GetFieldID(clsInfo, "mP2SSpeed", "J");
    env->SetLongField(taskInfo, fieldInfo, detail.taskInfo.p2s.speed);

    fieldInfo = env->GetFieldID(clsInfo, "mP2SRecvBytes", "J");
    env->SetLongField(taskInfo, fieldInfo, detail.taskInfo.p2s.recv_bytes);

    fieldInfo = env->GetFieldID(clsInfo, "mP2PSpeed", "J");
    env->SetLongField(taskInfo, fieldInfo, detail.taskInfo.p2p.speed);

    fieldInfo = env->GetFieldID(clsInfo, "mP2PRecvBytes", "J");
    env->SetLongField(taskInfo, fieldInfo, detail.taskInfo.p2p.recv_bytes);

    //暂时不返回离线/高速
    fieldInfo = env->GetFieldID(clsInfo, "mAdditionalResCount", "I");
    env->SetIntField(taskInfo, fieldInfo, 2);

    //if (queryMode == 1) {
		int i = 0;
		long vipSpeed = (detail.taskInfo.additional_res.p_infos + i)->speed;
		fieldInfo = env->GetFieldID(clsInfo, "mAdditionalResVipSpeed", "J");
		env->SetLongField(taskInfo, fieldInfo, vipSpeed);

		long vipRecvBytes = (detail.taskInfo.additional_res.p_infos + i)->recv_bytes;
		fieldInfo = env->GetFieldID(clsInfo, "mAdditionalResVipRecvBytes", "J");
		env->SetLongField(taskInfo, fieldInfo, vipRecvBytes);

		i++;
		long highSpeed = (detail.taskInfo.additional_res.p_infos + i)->speed;
		fieldInfo = env->GetFieldID(clsInfo, "mAdditionalResPeerSpeed", "J");
		env->SetLongField(taskInfo, fieldInfo, highSpeed);

		long highBytes = (detail.taskInfo.additional_res.p_infos + i)->recv_bytes;
		fieldInfo = env->GetFieldID(clsInfo, "mAdditionalResPeerBytes", "J");
		env->SetLongField(taskInfo, fieldInfo, highBytes);

		delete[] detail.taskInfo.additional_res.p_res_types;
		delete[] detail.taskInfo.additional_res.p_infos;
		ANDROID_DEBUG_LOG("function %s begin ------------vipSpeed=%lu, vipRecvBytes=%lu, highSpeed=%lu, highBytes=%lu",
				__FUNCTION__, vipSpeed, vipRecvBytes, highSpeed, highBytes);
    //}

    env->SetObjectField(subTaskDetailObj, field, taskInfo);

    env->DeleteLocalRef(cls);
    env->DeleteLocalRef(clsInfo);
    env->DeleteLocalRef(taskInfo);

    ANDROID_DEBUG_LOG("function %s end, taskId = %llu, ret = %d", __FUNCTION__, taskId, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    selectBtSubTask
 * Signature: (JLcom/xunlei/downloadlib/parameter/BtIndexSet;I)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_selectBtSubTask
  (JNIEnv *env, jobject obj, jlong taskId, jobject indexSetObj)
{
	jclass cls;
	jfieldID field;

	cls = env->GetObjectClass(indexSetObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get class indexSetObj error!", __FUNCTION__, taskId);
		return XL_JNI_ERROR;
	}

	field = env->GetFieldID(cls, "mIndexSet", "[I");
	jintArray indexSetArray = (jintArray)env->GetObjectField(indexSetObj, field);
	jsize count = env->GetArrayLength(indexSetArray);

	jint *indexSet = env->GetIntArrayElements(indexSetArray, NULL);
	jint ret = XLBtSelectSubTask(taskId, (uint32_t *)indexSet, count);
	ANDROID_DEBUG_LOG("function %s, taskid = %llu, count = %d", __FUNCTION__, taskId, count);
#ifdef __ANDROID_LOG__
	for (jint i = 0; i < count; i++)
	{
		ANDROID_DEBUG_LOG("function %s, taskid = %llu, indexSet[%d] = %d",
				__FUNCTION__, taskId, i, indexSet[i]);
	}
#endif
	env->ReleaseIntArrayElements(indexSetArray, indexSet, JNI_ABORT);

	env->DeleteLocalRef(cls);
	env->DeleteLocalRef(indexSetArray);

	ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    deselectBtSubTask
 * Signature: (JLcom/xunlei/downloadlib/parameter/BtIndexSet;I)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_deselectBtSubTask
  (JNIEnv *env, jobject obj, jlong taskId, jobject indexSetObj)
{
	jclass cls;
	jfieldID field;

	cls = env->GetObjectClass(indexSetObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get class indexSetObj error!", __FUNCTION__, taskId);
		return XL_JNI_ERROR;
	}

	field = env->GetFieldID(cls, "mIndexSet", "[I");
	jintArray indexSetArray = (jintArray)env->GetObjectField(indexSetObj, field);
	jsize count = env->GetArrayLength(indexSetArray);

	jint *indexSet = env->GetIntArrayElements(indexSetArray, NULL);
	jint ret = XLBtDeselectSubTask(taskId, (uint32_t *)indexSet, count);
	ANDROID_DEBUG_LOG("function %s, taskid = %llu, count = %d", __FUNCTION__, taskId, count);
#ifdef __ANDROID_LOG__
	for (jint i = 0; i < count; i++)
	{
		ANDROID_DEBUG_LOG("function %s, taskid = %llu, indexSet[%d] = %d",
				__FUNCTION__, taskId, i, indexSet[i]);
	}
#endif
	env->ReleaseIntArrayElements(indexSetArray, indexSet, JNI_ABORT);

	env->DeleteLocalRef(cls);
	env->DeleteLocalRef(indexSetArray);

	ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    btAddServerResource
 * Signature: (JILjava/lang/String;Ljava/lang/String;Ljava/lang/String;II)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_btAddServerResource
  (JNIEnv *env, jobject obj, jlong taskId, jint subIndex, jstring url, jstring refUrl, jstring cookie, jint resType, jint strategy)
{
	char *pUrl = (char *) env->GetStringUTFChars(url, NULL);
	char *pRefUrl = (char *) env->GetStringUTFChars(refUrl, NULL);
	char *pCookie = (char *) env->GetStringUTFChars(cookie, NULL);

	ANDROID_DEBUG_LOG("function %s, taskId = %llu, subIndex = %d, url = %s, refUrl = %s, cookie = %s, resType = %d, strategy = %d",
					  __FUNCTION__, taskId, subIndex, pUrl, pRefUrl, pCookie, resType, strategy);

	resType = XL_JNI_SERVER_RES;	//忽略上层设置的类型值，统一由JNI层维护，避免添加和查询的类型取值不对称

	int urlSize = (NULL != pUrl) ? strlen(pUrl) : 0;
	int refUrlSize = (NULL != pRefUrl) ? strlen(pRefUrl) : 0;
	int cookieSize = (NULL != pCookie) ? strlen(pCookie) : 0;

	jint ret = XLBtAddServerResource(taskId, subIndex, urlSize, pUrl, refUrlSize, pRefUrl,
			cookieSize, pCookie, resType, (RES_USE_STRATEGY) strategy);

	/*
	 * release memory
	 */
	releaseString(url, pUrl);
	releaseString(refUrl, pRefUrl);
	releaseString(cookie, pCookie);

	ANDROID_DEBUG_LOG("function %s end, taskId = %llu, ret = %d", __FUNCTION__, taskId, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    btAddPeerResource
 * Signature: (JILjava/lang/String;JLjava/lang/String;Ljava/lang/String;IIIIIII)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_btAddPeerResource
  (JNIEnv *env, jobject obj, jlong taskId, jint subIndex, jstring peerID, jlong userId, jstring jmpKey, jstring vipCdnAuth,
		  jint internalIp, jint tcpPort, jint udpPort, jint resLevel, jint resPriority, jint capabilityFlag, jint resType)
{
	char *pPeerID = (char *) env->GetStringUTFChars(peerID, NULL);
	char *pJmpKey = (char *) env->GetStringUTFChars(jmpKey, NULL);
	char *pVipCdnAuth = (char *) env->GetStringUTFChars(vipCdnAuth, NULL);

	ANDROID_DEBUG_LOG("function %s, taskId = %llu, subIndex = %d, peerID = %s, userId = %llu, jmpKey = %s, vipCdnAuth = %s, "
			"internalIp = %d, tcpPort = %d, udpPort = %d, resLevel  = %d, resPriority = %d, capabilityFlag = %d, appDefinedType = %d",
			__FUNCTION__, taskId, subIndex, pPeerID, userId, pJmpKey, pVipCdnAuth, internalIp, tcpPort, udpPort, resLevel, resPriority, capabilityFlag, resType);

	resType = XL_JNI_PEER_RES;	//忽略上层设置的类型值，统一由JNI层维护，避免添加和查询的类型取值不对称

	int peerIDSize = (NULL != pPeerID) ? strlen(pPeerID) : 0;
	int jmpKeySize = (NULL != pJmpKey) ? strlen(pJmpKey) : 0;
	int vipCdnAuthSize = (NULL != pVipCdnAuth) ? strlen(pVipCdnAuth) : 0;

	jint ret = XLBtAddPeerResource(taskId, subIndex, pPeerID, peerIDSize, userId, pJmpKey, jmpKeySize, pVipCdnAuth, vipCdnAuthSize,
			internalIp, tcpPort, udpPort, resLevel, resPriority, capabilityFlag, resType);

	/*
	 * release memory
	 */
	releaseString(peerID, pPeerID);
	releaseString(jmpKey, pJmpKey);
	releaseString(vipCdnAuth, pVipCdnAuth);

	ANDROID_DEBUG_LOG("function %s end, taskId = %llu, ret = %d", __FUNCTION__, taskId, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    btRemoveAddedResource
 * Signature: (JII)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_btRemoveAddedResource
  (JNIEnv *env, jobject obj, jlong taskId, jint subIndex, jint resType)
{
	jint ret = XLBtRemoveAddedResource(taskId, subIndex, resType);
	ANDROID_DEBUG_LOG("function %s end, taskId = %llu, subIndex = %d, resType = %d, ret = %d", __FUNCTION__, taskId, subIndex, resType, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    createEmuleTask
 * Signature: (Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IILcom/xunlei/downloadlib/parameter/GetTaskId;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_createEmuleTask
  (JNIEnv *env, jobject obj, jstring url, jstring filePath, jstring fileName, jint createMode, jint seqId, jobject taskIdObj)
{
	TaskParamEmule stTaskParamEmule;

	stTaskParamEmule.mode = (XL_CREATE_TASK_MODE)createMode;
	stTaskParamEmule.nSeqId = seqId;

	stTaskParamEmule.pstrUrl = env->GetStringUTFChars(url, NULL);
	stTaskParamEmule.nUrlSize = (NULL != stTaskParamEmule.pstrUrl) ? strlen(stTaskParamEmule.pstrUrl) : 0;

	stTaskParamEmule.pstrFilePath = env->GetStringUTFChars(filePath, NULL);
	stTaskParamEmule.nFilePathSize = (NULL != stTaskParamEmule.pstrFilePath) ? strlen(stTaskParamEmule.pstrFilePath) : 0;

	stTaskParamEmule.pstrFileName = env->GetStringUTFChars(fileName, NULL);
	stTaskParamEmule.nFileNameSize = (NULL != stTaskParamEmule.pstrFileName) ? strlen(stTaskParamEmule.pstrFileName) : 0;

	ANDROID_DEBUG_LOG("function %s stTaskParamMagnet, url = %s, filePath = %s, fileName = %s, createMode = %d, seqId = %d",
					  __FUNCTION__, stTaskParamEmule.pstrUrl, stTaskParamEmule.pstrFilePath, stTaskParamEmule.pstrFileName,
					  stTaskParamEmule.mode, stTaskParamEmule.nSeqId);

	uint64_t taskId = -1;
	jint ret = XLCreateEmuleTask(&stTaskParamEmule, &taskId);

	jclass cls = env->GetObjectClass(taskIdObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get class task_id_obj error!",  __FUNCTION__, taskId);

		releaseString(url, stTaskParamEmule.pstrUrl);
		releaseString(filePath, stTaskParamEmule.pstrFilePath);
		releaseString(fileName, stTaskParamEmule.pstrFileName);
		return  XL_JNI_ERROR;
	}

	jfieldID field = env->GetFieldID(cls, "mTaskId", "J");
	if (field == NULL) {
		ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get field error!", __FUNCTION__, taskId);

		releaseString(url, stTaskParamEmule.pstrUrl);
		releaseString(filePath, stTaskParamEmule.pstrFilePath);
		releaseString(fileName, stTaskParamEmule.pstrFileName);
		env->DeleteLocalRef(cls);
		return XL_JNI_ERROR;
	}
	env->SetLongField(taskIdObj, field, taskId);

	releaseString(url, stTaskParamEmule.pstrUrl);
	releaseString(filePath, stTaskParamEmule.pstrFilePath);
	releaseString(fileName, stTaskParamEmule.pstrFileName);
	env->DeleteLocalRef(cls);

	ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    getUrlQuickInfo
 * Signature: (JLcom/xunlei/downloadlib/parameter/UrlQuickInfo;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getUrlQuickInfo
  (JNIEnv *env, jobject obj, jlong taskId, jobject urlQuickInfoObj)
{
	ANDROID_DEBUG_LOG("function %s begin, taskId = %llu", __FUNCTION__, taskId);

	jclass cls;
	jfieldID field;

	cls = env->GetObjectClass(urlQuickInfoObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, get class urlQuickInfoObj error!", __FUNCTION__);
		return XL_JNI_ERROR;
	}

	UrlQuickInfo urlQuickInfo;
	memset(&urlQuickInfo, 0, sizeof(UrlQuickInfo));
	jint ret = XLGetUrlQuickInfo(taskId, &urlQuickInfo);
	if(XL_NO_ERRNO != ret){
		ANDROID_DEBUG_LOG("function %s end, get UrlQuickInfo failed, ret = %d", __FUNCTION__, ret);
		env->DeleteLocalRef(cls);
		return ret;
	}

	ANDROID_DEBUG_LOG("function %s----taskid:%llu, state:%d, fileNameAdvice:%s, contentType:%s, fileSize:%lld",
			__FUNCTION__, taskId, urlQuickInfo.state, urlQuickInfo.fileNameAdvice, urlQuickInfo.contentType, urlQuickInfo.fileSize);

	field = env->GetFieldID(cls, "mState", "I");
	env->SetIntField(urlQuickInfoObj, field, urlQuickInfo.state);

	jstring jsFileNameAdvice;
	if('\0' != urlQuickInfo.fileNameAdvice[0]){
		jsFileNameAdvice = strToJstring(env, urlQuickInfo.fileNameAdvice);
	}else{
		jsFileNameAdvice = env->NewStringUTF("");
	}
	field = env->GetFieldID(cls, "mFileNameAdvice", "Ljava/lang/String;");
	env->SetObjectField(urlQuickInfoObj, field, jsFileNameAdvice);

	jstring jsContentType;
	if('\0' != urlQuickInfo.contentType[0]){
		jsContentType = strToJstring(env, urlQuickInfo.contentType);
	}else{
		jsContentType = env->NewStringUTF("");
	}
	field = env->GetFieldID(cls, "mContentType", "Ljava/lang/String;");
	env->SetObjectField(urlQuickInfoObj, field, jsContentType);

	field = env->GetFieldID(cls, "mFileSize", "J");
	env->SetLongField(urlQuickInfoObj, field, urlQuickInfo.fileSize);

	ANDROID_DEBUG_LOG("function %s end ------------", __FUNCTION__);

	env->DeleteLocalRef(cls);
	env->DeleteLocalRef(jsFileNameAdvice);
	env->DeleteLocalRef(jsContentType);

	return ret;
}

/*
 * Class:     com_xunlei_downloadlib_XLLoader
 * Method:    createCIDTask
 * Signature: (Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;JIILcom/xunlei/downloadlib/parameter/GetTaskId;)I
 */
JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_createCIDTask
  (JNIEnv *env, jobject obj, jstring cid, jstring gcid, jstring bcid, jstring filePath, jstring fileName, jlong fileSize, jint createMode, jint seqId, jobject taskIdObj)
{
	TaskParamCID stTaskParamCID;

	stTaskParamCID.mode = (XL_CREATE_TASK_MODE)createMode;
	stTaskParamCID.nSeqId = seqId;

	stTaskParamCID.pCid = env->GetStringUTFChars(cid, NULL);
	stTaskParamCID.nCidSize = (NULL != stTaskParamCID.pCid) ? strlen(stTaskParamCID.pCid) : 0;

	if(NULL != gcid){
		stTaskParamCID.pGcid = env->GetStringUTFChars(gcid, NULL);
	}else{
		stTaskParamCID.pGcid = "";
	}
	stTaskParamCID.nGcidSize = (NULL != stTaskParamCID.pGcid) ? strlen(stTaskParamCID.pGcid) : 0;

	if(NULL != bcid){
		stTaskParamCID.pBcid = env->GetStringUTFChars(bcid, NULL);
	}else{
		stTaskParamCID.pBcid = "";
	}
	stTaskParamCID.nBcidSize = (NULL != stTaskParamCID.pBcid) ? strlen(stTaskParamCID.pBcid) : 0;

	stTaskParamCID.pstrFilePath = env->GetStringUTFChars(filePath, NULL);
	stTaskParamCID.nFilePathSize = (NULL != stTaskParamCID.pstrFilePath) ? strlen(stTaskParamCID.pstrFilePath) : 0;

	stTaskParamCID.pstrFileName = env->GetStringUTFChars(fileName, NULL);
	stTaskParamCID.nFileNameSize = (NULL != stTaskParamCID.pstrFileName) ? strlen(stTaskParamCID.pstrFileName) : 0;

	stTaskParamCID.nFileSize = fileSize;

	ANDROID_DEBUG_LOG("function %s stTaskParamCID, cid = %s, gcid = %s, bcid = %s, filePath = %s, fileName = %s, fileSize = %llu, createMode = %d, seqId = %d",
					  __FUNCTION__, stTaskParamCID.pCid, stTaskParamCID.pGcid, stTaskParamCID.pBcid, stTaskParamCID.pstrFilePath, stTaskParamCID.pstrFileName,
					  fileSize, stTaskParamCID.mode, stTaskParamCID.nSeqId);

	uint64_t taskId = -1;
	jint ret = XLCreateCIDTask(&stTaskParamCID, &taskId);

	jclass cls = env->GetObjectClass(taskIdObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get class task_id_obj error!",  __FUNCTION__, taskId);

		releaseString(cid, stTaskParamCID.pCid);
		releaseString(gcid, stTaskParamCID.pGcid);
		releaseString(bcid, stTaskParamCID.pBcid);
		releaseString(filePath, stTaskParamCID.pstrFilePath);
		releaseString(fileName, stTaskParamCID.pstrFileName);
		return  XL_JNI_ERROR;
	}

	jfieldID field = env->GetFieldID(cls, "mTaskId", "J");
	if (field == NULL) {
		ANDROID_DEBUG_LOG("function %s end, taskid = %llu, get field error!", __FUNCTION__, taskId);

		releaseString(cid, stTaskParamCID.pCid);
		releaseString(gcid, stTaskParamCID.pGcid);
		releaseString(bcid, stTaskParamCID.pBcid);
		releaseString(filePath, stTaskParamCID.pstrFilePath);
		releaseString(fileName, stTaskParamCID.pstrFileName);
		env->DeleteLocalRef(cls);
		return XL_JNI_ERROR;
	}
	env->SetLongField(taskIdObj, field, taskId);

	releaseString(cid, stTaskParamCID.pCid);
	releaseString(gcid, stTaskParamCID.pGcid);
	releaseString(bcid, stTaskParamCID.pBcid);
	releaseString(filePath, stTaskParamCID.pstrFilePath);
	releaseString(fileName, stTaskParamCID.pstrFileName);
	env->DeleteLocalRef(cls);

	ANDROID_DEBUG_LOG("function %s end, taskid = %llu, ret = %d", __FUNCTION__, taskId, ret);
	return ret;
}

JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_parserThunderUrl
  (JNIEnv *env, jobject obj, jstring thunderUrl, jobject thunderUrlInfoObj)
{
	const char* url = env->GetStringUTFChars(thunderUrl, NULL);
	int urlSize = (NULL != url) ? strlen(url) : 0;

	ANDROID_DEBUG_LOG("function %s begin, url: %s, urlSize: %d!", __FUNCTION__, url, urlSize);

	ThunerUrlInfo thunderUrlInfo;
	memset(&thunderUrlInfo, 0, sizeof(thunderUrlInfo));
	jint ret = XLParserThunderUrl(url, urlSize, &thunderUrlInfo);

	jclass cls = env->GetObjectClass(thunderUrlInfoObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, get class task_id_obj error!",  __FUNCTION__);

		releaseString(thunderUrl, url);
		return  XL_JNI_ERROR;
	}

	jfieldID field = env->GetFieldID(cls, "mUrl", "Ljava/lang/String;");
	if (field == NULL) {
		ANDROID_DEBUG_LOG("function %s end, get field error!", __FUNCTION__);

		releaseString(thunderUrl, url);
		env->DeleteLocalRef(cls);
		return XL_JNI_ERROR;
	}
	jstring jsUrl = strToJstring(env, thunderUrlInfo.url);
	env->SetObjectField(thunderUrlInfoObj, field, jsUrl);

	releaseString(thunderUrl, url);
	env->DeleteLocalRef(jsUrl);
	env->DeleteLocalRef(cls);

	ANDROID_DEBUG_LOG("function %s end, ret = %d", __FUNCTION__, ret);

	return ret;

}

JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getFileNameFromUrl
  (JNIEnv *env, jobject obj, jstring url, jobject fileNameObj)
{
	const char* pUrl = env->GetStringUTFChars(url, NULL);
    int urlLen = (NULL != pUrl) ? strlen(pUrl) : 0;

    char fileName[256];

    jint ret = XLGetFileNameFromUrl(pUrl, urlLen, fileName, 256);
    if(XL_NO_ERRNO != ret){
    	ANDROID_DEBUG_LOG("function %s end, get getFileNameFromUrl failed, ret = %d", __FUNCTION__, ret);
    	return ret;
    }

    jclass cls = env->GetObjectClass(fileNameObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, get class fileNameObj error!",  __FUNCTION__);
		releaseString(url, pUrl);
		return  XL_JNI_ERROR;
	}

	jfieldID field = env->GetFieldID(cls, "mFileName", "Ljava/lang/String;");
	if (field == NULL) {
		ANDROID_DEBUG_LOG("function %s end, get field error!", __FUNCTION__);
		releaseString(url, pUrl);
		env->DeleteLocalRef(cls);
		return XL_JNI_ERROR;
	}
	jstring jsFileName = strToJstring(env, fileName);
	env->SetObjectField(fileNameObj, field, jsFileName);

	releaseString(url, pUrl);
	env->DeleteLocalRef(jsFileName);
	env->DeleteLocalRef(cls);

	ANDROID_DEBUG_LOG("function %s end, ret = %d", __FUNCTION__, ret);

	return ret;

}

JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getFileNameFromHlsUrl
  (JNIEnv *env, jobject obj, jstring url, jobject fileNameObj)
{
	const char* pUrl = env->GetStringUTFChars(url, NULL);
    int urlLen = (NULL != pUrl) ? strlen(pUrl) : 0;

    char fileName[256];

    jint ret = XLGetFileNameFromHlsUrl(pUrl, urlLen, fileName, 256);
    if(XL_NO_ERRNO != ret){
    	ANDROID_DEBUG_LOG("function %s end, get getFileNameFromUrl failed, ret = %d", __FUNCTION__, ret);
    	return ret;
    }

    jclass cls = env->GetObjectClass(fileNameObj);
	if (NULL == cls) {
		ANDROID_DEBUG_LOG("function %s end, get class fileNameObj error!",  __FUNCTION__);
		releaseString(url, pUrl);
		return  XL_JNI_ERROR;
	}

	jfieldID field = env->GetFieldID(cls, "mFileName", "Ljava/lang/String;");
	if (field == NULL) {
		ANDROID_DEBUG_LOG("function %s end, get field error!", __FUNCTION__);
		releaseString(url, pUrl);
		env->DeleteLocalRef(cls);
		return XL_JNI_ERROR;
	}
	jstring jsFileName = strToJstring(env, fileName);
	env->SetObjectField(fileNameObj, field, jsFileName);

	releaseString(url, pUrl);
	env->DeleteLocalRef(jsFileName);
	env->DeleteLocalRef(cls);

	ANDROID_DEBUG_LOG("function %s end, ret = %d", __FUNCTION__, ret);

	return ret;

}

JNIEXPORT jint JNICALL Java_com_xunlei_downloadlib_XLLoader_getNameFromUrl
  (JNIEnv *env, jobject obj, jstring url, jstring fileName)
{
	const char* pUrl = env->GetStringUTFChars(url, NULL);
	int urlLen = (NULL != pUrl) ? strlen(pUrl) : 0;

	char name[256];

	jint ret = XLGetFileNameFromUrl(pUrl, urlLen, name, 256);
	if(XL_NO_ERRNO != ret){
		ANDROID_DEBUG_LOG("function %s end, get getFileNameFromUrl failed, ret = %d", __FUNCTION__, ret);
		return ret;
	}

	jstring jsFileName = strToJstring(env, name);
	fileName = jsFileName;

	releaseString(url, pUrl);
	env->DeleteLocalRef(jsFileName);

	ANDROID_DEBUG_LOG("function %s end, ret = %d", __FUNCTION__, ret);

	return ret;
}

void bin2hex(char *bin, unsigned int binLen, char *hex) {
    int pos = 0;
    int offset = 0;
    memset(hex, 0, binLen * 2 + 1);
    while (pos < binLen) {
        offset += sprintf(hex + offset, "%02X", (unsigned char) bin[pos]);
        pos++;
    }
}

void hex2bin(char *hex, unsigned int hexLen, char *bin) {
    int pos = 0;
    int offset = 0;
    long longChar;
    char *endptr;
    char tempHex[3] = "\0\0";
    memset(bin, 0, hexLen / 2 + 1);
    while (pos <= hexLen) {
        memcpy(tempHex, hex + pos, 2);
        longChar = strtol(tempHex, &endptr, 16);
        if (longChar) {
            offset += sprintf(bin + offset, "%c", (unsigned char) longChar);
        } else {
            offset++;
        }
        pos += 2;
    }
}

jstring strToJstring(JNIEnv* env, const char *pStr)
{
    int        strLen    = strlen(pStr);
    jclass     jstrObj   = env->FindClass("java/lang/String");
    jmethodID  methodId  = env->GetMethodID(jstrObj, "<init>", "([BLjava/lang/String;)V");
    jbyteArray byteArray = env->NewByteArray(strLen);
    jstring    encode    = env->NewStringUTF("utf-8");

    env->SetByteArrayRegion(byteArray, 0, strLen, (jbyte*)pStr);

    jstring str = (jstring)(env->NewObject(jstrObj, methodId, byteArray, encode));

    env->DeleteLocalRef(byteArray);
    env->DeleteLocalRef(encode);
    env->DeleteLocalRef(jstrObj);

    return str;

}

}	/* extern "C" */
